<template>
  <div class="row">
  <form>
    <div class="form-group">
      <label for="postTitle">Title</label>
      <input type="text" class="form-control input-sm" 
                         id="postTitle" placeholder="title"
                         v-model="post.title">
    </div>
      <div class="panel-heading">
        <div class="btn-group">
        <button class="btn btn-default btn-sm"
          @click.prevent="addBbcode('url')"
          ><span class="glyphicon glyphicon-link" aria-hidden="true"></span></button>
        <button class="btn btn-default btn-sm"
          @click.prevent="addBbcode('img')"
          ><span class="glyphicon glyphicon-picture" aria-hidden="true"></span></button>
        <button class="btn btn-default btn-sm"
          @click.prevent="addBbcode('youtube')"
          ><span class="glyphicon glyphicon-facetime-video" aria-hidden="true"></span></button>
      </div>
        <div class="btn-group">
          <button class="btn btn-default btn-sm"
            @click.prevent="addBbcode('b')"><b>B</b></button>
          <button class="btn btn-default btn-sm"
            @click.prevent="addBbcode('i')"><i>i</i></button>
          <button class="btn btn-default btn-sm"
            @click.prevent="addBbcode('u')"><u>u</u></button>
        </div>
      </div>
      <textarea class="form-control" 
                id="postText" placeholder="text"
                v-model="post.content" rows="15"></textarea>

    <upload></upload>
    <div class="form-group">
      <label for="postTags">Tags</label>
      <input type="text" class="form-control input-sm" 
                         id="postTags" placeholder="tag1, tag2"
                         v-model="tags">
    </div>
    <button @click.prevent="postHandle" type="submit" class="btn btn-default">Submit</button>
  </form>
  </div>
</template>

<script>
import Upload from '../basic/Upload'

export default {
  name: 'PostCreate',
  components: {
    Upload
  },
  data () {
    return {
      post_id: '',
      post: {
        title: '',
        content: '',
        tags: []
      },
      isAuth: this.$store.getters.isAuthenticated,
      tags: '',
      action: this.$route.params.action,
      slug: this.$route.params.slug,
      date: this.$route.params.date
    }
  },
  methods: {
    addBbcode (tag) {
      if (tag === 'url') {
        this.post.content += ` [${tag}=http://yandex.ru]description[/${tag}]`
      } else {
        this.post.content += ` [${tag}][/${tag}]`
      }
    },
    setTags () {
      let tags = this.tags.split(',')
      this.post.tags = tags.filter(String).map(e => e.trim())
    },
    fetchPost () {
      this.$http.get(`blog/post/${this.date}/${this.slug}`)
        .then(response => {
          this.post_id = response.body._id.$oid
          this.post.title = response.body.title
          this.post.content = response.body.content_bbcode
          this.tags = response.body.tags.join(', ')
        })
    },
    postHandle () {
      this.setTags()
      if (this.action === 'create') {
        this.$http.post('blog/post', this.post)
          .then(response => {
            this.message = response.body
            this.$router.push({ name: 'blog' })
            this.$store.commit('addAlert', {
              type: 'success',
              message: 'Article was created'
            })
          }, error => {
            console.log(error)
          })
      } else if (this.action === 'edit') {
        this.$http.put(`blog/post/${this.post_id}`, this.post)
          .then(response => {
            this.message = response.body
            this.$store.commit('addAlert', {
              type: 'success',
              message: 'Article was updated'
            })
            console.log(this.message)
          }, error => {
            console.log(error)
          })
      }
    },
    watch: {
      $route (to, from) {
        this.action = to.params.action
        this.slug = to.params.slug
        this.date = to.params.date
      }
    }
  },
  beforeRouteEnter (to, from, next) {
    next(vm => {
      if (!vm.$store.getters.isAuthenticated) {
        vm.$router.push({ name: 'login' })
      }
    })
  },
  created () {
    if (this.action === 'edit') {
      this.fetchPost()
    }
  }
}
  </script>

<style scoped>
</style>
